/*************************************************************
  Download latest Blynk library here:
    https://github.com/blynkkk/blynk-library/releases/latest

  Blynk is a platform with iOS and Android apps to control
  Arduino, Raspberry Pi and the likes over the Internet.
  You can easily build graphic interfaces for all your
  projects by simply dragging and dropping widgets.

    Downloads, docs, tutorials: http://www.blynk.cc
    Sketch generator:           http://examples.blynk.cc
    Blynk community:            http://community.blynk.cc
    Follow us:                  http://www.fb.com/blynkapp
                                http://twitter.com/blynk_app

  Blynk library is licensed under MIT license
  This example code is in public domain.

 *************************************************************
  This example runs directly on ESP8266 chip.

  Note: This requires ESP8266 support package:
    https://github.com/esp8266/Arduino

  Please be sure to select the right ESP8266 module
  in the Tools -> Board menu!

  Change WiFi ssid, pass, and Blynk auth token to run :)
  Feel free to apply it to any other example. It's simple!
 *************************************************************/

/* Comment this out to disable prints and save space */
#define BLYNK_PRINT Serial

/* Fill-in your Template ID (only if using Blynk.Cloud) */

#define BLYNK_TEMPLATE_ID "TMPLvKAR9uy4"
#define BLYNK_DEVICE_NAME "Thermostat"
#define BLYNK_AUTH_TOKEN "5HSQFbg4VuYuMBoBSI9OsFP3iwfiLoXP"

#include <ESP8266WiFi.h>
#include <BlynkSimpleEsp8266.h>

#include <dht11.h>


// Your WiFi credentials.
// Set password to "" for open networks.
char ssid[] = "iPhone-Thierry";
char pass[] = "Essai-Fablab-201810";

dht11 DHT;
#define DHT11_PIN 14

BlynkTimer timer;

int Consigne;
int Marche;

// This function sends Arduino's up time every second to Virtual Pin (5).
// In the app, Widget's reading frequency should be set to PUSH. This means
// that you define how often to send data to Blynk App.
void sendUptime()
{
int LedOn;

  // You can send any value at any time.
  // Please don't send more that 10 values per second.
  Blynk.virtualWrite(0, DHT.temperature); //virtual pin
  Blynk.virtualWrite(1, DHT.humidity); // virtual pin
  LedOn = ((DHT.temperature < Consigne)&&Marche);
  Blynk.virtualWrite(4, LedOn*255); // virtual pin

}

BLYNK_WRITE(V3) //consigne pour temperature
{
  Consigne = param.asInt(); 
  Serial.print("Consigne="); Serial.println(Consigne);
}

BLYNK_WRITE(V2) //Marche arrêt
{
  Marche = param.asInt(); 
  Serial.print("Marche="); Serial.println(Marche);
  digitalWrite(BUILTIN_LED, Marche == 0);
}

BLYNK_CONNECTED()
{
  Blynk.syncVirtual(V3);  // will cause BLYNK_WRITE(V3) to be executed
  Blynk.syncVirtual(V2);  // will cause BLYNK_WRITE(V2) to be executed
}

void setup()
{
  // Debug console
  Serial.begin(115200);
  pinMode(BUILTIN_LED, OUTPUT);
  // Setup a function to be called every second
  timer.setInterval(1000L, sendUptime);
  Blynk.begin(BLYNK_AUTH_TOKEN, ssid, pass);
}

void loop()
{
  Blynk.run();
  timer.run(); // Initiates SimpleTimer
  int chk; 
  chk = DHT.read(DHT11_PIN);    // READ DATA
}
