#include <LittleFS.h>

#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>
ESP8266WebServer server(80);

#include <DHT.h>


String getContentType(String filename)
{ // convert the file extension to the MIME type
   if (filename.endsWith(".html")) return "text/html";
   else if (filename.endsWith(".css")) return "text/css";
   else if (filename.endsWith(".js")) return "application/javascript";
   else if (filename.endsWith(".ico")) return "image/x-icon";
   return "text/plain";
}

void ListDirLittleFS()
{
String str = "";
 Dir dir = LittleFS.openDir("/");
 while (dir.next()) {
    str += dir.fileName();
    str += " / ";
    str += dir.fileSize();
    str += "\r\n";
 }
 Serial.print(str);
}

bool handleFileRead(String path)
{ // send the right file to the client (if it exists)
 //Serial.println("handleFileRead: " + path);
 if (path.endsWith("/")) path += "index.html";         // If a folder is requested, send the index file
  String contentType = getContentType(path);            // Get the MIME type
  if (LittleFS.exists(path)) {                            // If the file exists
    File file = LittleFS.open(path, "r");                 // Open it
    size_t sent = server.streamFile(file, contentType); // And send it to the client
    file.close();                                       // Then close the file again
    return true;
 }
  Serial.print("File :"); Serial.print(path);Serial.println(" Not Found");
  return false;
}
IPAddress local_IP(192,168,4,2);
IPAddress gateway(192,168,4,1);
IPAddress subnet(255,255,252,0);
int WiFi_OK;
int WiFi_Mode = 1;
DHT dht_12_DHT11(12,DHT11);


String PageDemandee;
String JSON_Data;

// Décrire cette fonction
void ReadTemp() {
  handleFileRead( "/ThermoJSON.html" );
}


// Décrire cette fonction
void FonctionURLNotFound() {
  PageDemandee = String("La page demandée : ") + String(server.uri()) + String("n \'existe pas");
  server.send(404, "text/html", PageDemandee);
}


// Décrire cette fonction
void MakeJSON() {
  JSON_Data = String("{") + String('"') + String("Temp") + String('"') + String(" : ") + String('"') + String((int)(dht_12_DHT11.readTemperature())) + String(" °C") + String('"') + String(',') + String('"') + String("Hum") + String('"') + String(" : ") + String('"') + String((int)(dht_12_DHT11.readHumidity())) + String("%") + String('"') + String("}");
  Serial.print("Chaine JSON");
   Serial.println(JSON_Data);
  server.send(200, "data/json", JSON_Data);
}



void setup() {
  Serial.begin(115200);
  if(!LittleFS.begin()) {
  Serial.println("An Error has occurred while mounting LittleFS");
  return;
  }
  Serial.println("LittleFS Ready");

  WiFi_OK = WiFi.softAPConfig(local_IP, gateway, subnet);
WiFi_OK &= WiFi.softAP("ESP8266_SSID");

    ListDirLittleFS();
  server.on("/", ReadTemp);
  server.on("/DataTemp.json", MakeJSON);
  server.onNotFound(FonctionURLNotFound);
  server.begin();

  dht_12_DHT11.begin();

}

void loop() {
    server.handleClient();

}
